"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _default = function _default(_ref) {
  var fields = _ref.fields,
      validate = _ref.validate,
      validationOptions = _ref.validationOptions,
      onSubmit = _ref.onSubmit,
      _ref$defaultErrorMess = _ref.defaultErrorMessage,
      defaultErrorMessage = _ref$defaultErrorMess === void 0 ? "Looks like that didn't work. Please try again." : _ref$defaultErrorMess,
      _ref$forceShowOnSubmi = _ref.forceShowOnSubmit,
      forceShowOnSubmit = _ref$forceShowOnSubmi === void 0 ? true : _ref$forceShowOnSubmi;
  var validateFunc = validate || makeSimpleValidator(Object.keys(fields), defaultErrorMessage);
  var initialErrors = validateFunc(fields, validationOptions);

  var _useState = (0, _react.useState)(fields),
      _useState2 = _slicedToArray(_useState, 2),
      values = _useState2[0],
      setValues = _useState2[1];

  var _useState3 = (0, _react.useState)(initialErrors),
      _useState4 = _slicedToArray(_useState3, 2),
      errors = _useState4[0],
      setErrors = _useState4[1];

  var _useState5 = (0, _react.useState)({}),
      _useState6 = _slicedToArray(_useState5, 2),
      touched = _useState6[0],
      setTouched = _useState6[1];

  var handleChange = function handleChange(fieldName) {
    return function (eventOrValue) {
      var isSyntheticEvent = function isSyntheticEvent(e) {
        return e && e.target && _typeof(e.target) === 'object';
      };

      var newValues = _objectSpread({}, values, _defineProperty({}, fieldName, isSyntheticEvent(eventOrValue) ? eventOrValue.target.value : eventOrValue));

      setValues(newValues);
      setErrors(validateFunc(newValues, validationOptions));
    };
  };

  var handleBlur = function handleBlur(fieldName) {
    return function () {
      setTouched(_objectSpread({}, touched, _defineProperty({}, fieldName, true)));
    };
  };

  var handleSubmit = function handleSubmit(options) {
    if (forceShowOnSubmit) {
      // Set touched to true for all fields
      setTouched(Object.keys(fields).reduce(function (touched, fieldName) {
        return _objectSpread({}, touched, _defineProperty({}, fieldName, true));
      }, {}));
    }

    var isValid = Object.values(errors).reduce(function (isValid, error) {
      return isValid && !error;
    }, true);
    if (!isValid) return;
    onSubmit(values, options);
  };

  return {
    fields: Object.keys(fields).reduce(function (result, fieldName) {
      return _objectSpread({}, result, _defineProperty({}, fieldName, {
        error: errors[fieldName],
        touched: touched[fieldName],
        value: values[fieldName],
        onChange: handleChange(fieldName),
        onBlur: handleBlur(fieldName)
      }));
    }, {}),
    handleSubmit: handleSubmit
  };
};

exports.default = _default;

var makeSimpleValidator = function makeSimpleValidator(fieldNames, message) {
  return function (values) {
    return fieldNames.reduce(function (result, fieldName) {
      result[fieldName] = values[fieldName] === '' ? message : null;
      return result;
    }, {});
  };
};